/* 92/02/13 Markus Sigg, Parsytec Aachen 
   SCCSid:	@(#)master.c	1.1	5/15/92
 */

#include <sys/root.h>

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <signal.h>

#define MESSLEN		100
#define MAXBUFLEN	64 * 1024

/* heavy send to one slave: */

int
_wh (int size, int count, int desc)
{
    int             i;
    static char     buf[MAXBUFLEN];

    for (i = 0; i < count; i++)
	write (desc, buf, size);
}

int 
main (int argc, char **argv)
{
    int             size;
    int             anz, i, myx, myy;
    int             werr;
    static char     buf[MESSLEN];
    char            pbuf[100];

    setvbuf (stderr, pbuf, _IOLBF, sizeof (pbuf));

    anz = atoi (argv[1]);
    myx = GET_ROOT ()->ProcRoot->MyX;
    myy = GET_ROOT ()->ProcRoot->MyY;
    fprintf (stderr, "This is master on processor (%d, %d).\n", myx, myy);

    for (i = 0; i < anz; i++) {
	sprintf (buf, "Mess. from master (desc. %d).", 5 + i + i);
	write (5 + i + i, buf, strlen (buf) + 1);
    }

    fprintf (stderr, "Starting heavy communication !\n");

    for (size = 1; size < MAXBUFLEN + 1; size *= 2) {
	int             count;
	double          t, t1;

	if (size < 256)
	    count = 256;
	else
	    count = 16;

	t = (double) TimeNowLow ();
	for (i = 0; i < anz; i++)
	    if (StartThread (_wh, MAXBUFLEN + 5000, &werr, 12,
			     size, count, 5 + i + i) == NULL) {
		LogError (EC_FATAL,
			  "master",
			  "Couldn't start thread - out of memory.");
		kill (getpid (), SIGINT);
	    }

	for (i = 0; i < anz; i++) {
	    Thread_t       *tp;

	    tp = WaitThread (NULL, NULL);
	    WaitThread (tp, NULL);
	}
	t1 = ((double) TimeNowLow () - t) / ((double) CLK_TCK_LOW / 1000.0);

	fprintf (stderr, "Master: sent %d bytes %d times to %d slaves (= %d k) in %.2f msec = %0.2f k/s.\n",
		 size, count, anz, size * count * anz / 1024, t1,
		 (double) size * count * anz / 1024 * 1000 / t1);
    }

    for (i = 0; i < anz; i++) {
	read (4 + i + i, buf, MESSLEN);
	fprintf (stderr, "Master: %s (got on desc. %d).\n", buf, 4 + i + i);
    }

    fprintf (stderr, "Master: DONE !\n");

    exit (0);
}



