/* This is the first example program presented in the Programmer's Guide 
   SCCSid:	@(#)example1.c	1.2	5/20/92
 */

#include <sys/root.h>
#include <sys/link.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int             MyProcID;		/* ID of this processor */


int
Harry (void)
{
    char           *FName = "Harry";

    LinkCB_t       *TonyLink;
    int             error, i;
    char            answer[100];

 /* make link to Tony */
    TonyLink = MakeLink (MyProcID, 1234, &error);
    if (TonyLink == NULL) {
	LogError (EC_ERROR, FName,
		  "Failed to make link to Tony, error code %d.", error);
	exit (1);
    }

    for (i = 0; i < 2; i++) {
    /* talk with Tony */
	static char    *question[] = {
	    "How are you ?",
	    "What do you think of PARIX ?"
	};

	printf ("Talk to Tony: %s\n", question[i]);
	SendLink (TonyLink, (byte *) question[i], strlen (question[i]) + 1);
	RecvLink (TonyLink, (byte *) answer, 1024);
	printf ("Answer from Tony: %s\n\n", answer);
    }

    return 0;
}


int
Tony (void)
{
    char           *FName = "Tony";

    LinkCB_t       *HarryLink;
    int             error, i;
    char            question[100], *answer;

 /* make link to Harry */
    HarryLink = GetLink (MyProcID, 1234, &error);
    if (HarryLink == NULL) {
	LogError (EC_ERROR, FName,
		  "Failed to get link from Harry, error code %d.", error);
	exit (1);
    }

    for (i = 0; i < 2; i++) {
    /* receive message from Harry */
	RecvLink (HarryLink, (byte *) question, 1024);

	if (strstr (question, "PARIX") == NULL)
	    answer = "Eh ?";
	else
	    answer = "GREAT !";

    /* send answer */
	SendLink (HarryLink, (byte *) answer, strlen (answer) + 1);
    }

    return 0;
}


int
main (void)
{
    char           *FName = "main";

    Thread_t       *HarryThread, *TonyThread;
    int             error, result;

 /* determine ID of processor (used in MakeLink / GetLink) */
    MyProcID = GET_ROOT ()->ProcRoot->MyProcID;

 /* start Harry */
    HarryThread = StartThread (Harry, 4096, &error, 0);
    if (HarryThread == NULL) {
	LogError (EC_ERROR, FName,
		  "Failed to start Harry, error code %d.", error);
	exit (1);
    }

 /* start Tony */
    TonyThread = StartThread (Tony, 4096, &error, 0);
    if (TonyThread == NULL) {
	LogError (EC_ERROR, FName,
		  "Failed to start Tony, error code %d.", error);
	exit (1);
    }

 /* wait until Harry and Tony have finished their chat */
    WaitThread (HarryThread, &result);
    WaitThread (TonyThread, &result);

    exit (0);
}
