/* This is the second example program presented in the Programmer's Guide 
   SCCSid:	@(#)example2.c	1.3	5/20/92
 */

#include <sys/root.h>
#include <sys/link.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/sys_rpc.h>
#include <unistd.h>


int
main (void)
{
    char           *FName = "main";

    int             MyProcID;		/* ID of this processor */
    int             nProcs;		/* number of processors */
    LinkCB_t       *PrevLink, *NextLink;
    int             error;

 /* determine ID of processor (used in MakeLink / GetLink) */
    MyProcID = GET_ROOT ()->ProcRoot->MyProcID;
    nProcs = GET_ROOT ()->ProcRoot->nProcs;

    if (nProcs < 2) {
	printf ("Your network is too small !\n");
	AbortServer (1);
    }

    if (MyProcID == 0) {
    /* make link to next processor */
	NextLink = MakeLink ((MyProcID + 1) % nProcs, 1234, &error);
	if (NextLink == NULL) {
	    LogError (EC_ERROR, FName,
	    "Failed to make link to next processor, error code %d.", error);
	    AbortServer (1);
	}

    /* get link from previous processor */
	PrevLink = GetLink ((MyProcID - 1 + nProcs) % nProcs, 1234, &error);
	if (PrevLink == NULL) {
	    LogError (EC_ERROR, FName,
		      "Failed to get link from previous processor, error code %d.", error);
	    AbortServer (1);
	}
    }

    else {
    /* get link from previous processor */
	PrevLink = GetLink ((MyProcID - 1 + nProcs) % nProcs, 1234, &error);
	if (PrevLink == NULL) {
	    LogError (EC_ERROR, FName,
		      "Failed to get link from previous processor, error code %d.", error);
	    AbortServer (1);
	}

    /* make link to next processor */
	NextLink = MakeLink ((MyProcID + 1) % nProcs, 1234, &error);
	if (NextLink == NULL) {
	    LogError (EC_ERROR, FName,
	    "Failed to make link to next processor, error code %d.", error);
	    AbortServer (1);
	}
    }

    {
	if (MyProcID == 0) {
	    int length;
	    char            original[1024], result[1024];

	    printf ("Input test textline :\n");
	    length = read (0, original, 1024);
	    SendLink (NextLink, original, length);
	    length = RecvLink (PrevLink, result, 1024);
	    result[length] = (char) 0;
	    printf ("Received from ring: %s\n", result);
	}
	else {
	    int length;
	    char            buffer[1024];

	    length = RecvLink (PrevLink, buffer, 1024);
	    SendLink (NextLink, buffer, length);
	}
    }

    exit (0);
}
