/* SCCSid:	@(#)ManyThreads.c	1.2	5/18/92
 */

#include <sys/root.h>
#include <stdio.h>
#include <stdlib.h>

#define TICKS_PER_SECOND	15625

int
DummyThread (int *running, int *count)
{
    while (*running) {
	*count = *count + 1;
	TimeWaitLow (TimeNowLow () + TICKS_PER_SECOND);
    }
}

typedef struct ThreadList {
    Thread_t       *ThreadPnt;
    int             count;
    struct ThreadList *Next;
}               ThreadList_t;

int
main (void)
{
    char           *FName = "main";

    unsigned int    StartTime;
    int             n;			/* number of started threads */
    int             ok;
    ThreadList_t    ThreadList, *ActualThread;
    int             error, result, running;

    n = 0;
    ActualThread = &ThreadList;
    ok = TRUE;

    printf ("Starting threads until out of memory !\n");
    running = TRUE;
    StartTime = TimeNowLow ();
    ChangePriority (HIGH_PRIORITY);
    while (ok) {
	ActualThread->count = 0;
	ActualThread->ThreadPnt =
	  StartThread (DummyThread, 1024, &error,
		       8, &running, &ActualThread->count);
	if (ActualThread->ThreadPnt == NULL)
	    ok = FALSE;
	else {
	    n++;
	    if (n % 100 == 0) {
		printf ("%d threads started in %f seconds, thread 0 counted up to %d.\n",
			n, (float) (TimeNowLow () - StartTime) / (float) TICKS_PER_SECOND, ThreadList.count);
	    }
	    ActualThread->Next =
	      (ThreadList_t *) malloc (sizeof (ThreadList_t));
	    if (ActualThread->Next == NULL)
		ok = FALSE;
	    else
		ActualThread = ActualThread->Next;
	}
    }

    printf ("Out of memory running %d threads, terminating all threads.\n", n);
    running = FALSE;
    n = 0;
    ActualThread = &ThreadList;

    while (ActualThread->ThreadPnt != NULL) {
	if (WaitThread (ActualThread->ThreadPnt, &result) == NULL) {
	    LogError (EC_ERROR, FName,
		      "Error terminating thread %d.", n);
	    exit (1);
	}
	n++;
	if (n % 100 == 0)
	    printf ("%d threads terminated.\n", n);
	ActualThread = ActualThread->Next;
    }

    printf ("All threads have terminated !\n\n");
    ChangePriority (LOW_PRIORITY);	/* return to low pri to give the
					 * router a chance */
    exit (0);
}
