#ifndef AR_H
#define AR_H

/*
 * SCCS:	@(#)ar.h	92.1	92/12/09	(c) ACE
 *
 * ACE-COFF Utilities.
 *
 * This source file is part of the ACE Compiler Family.
 * Copyright reserved. This source file, or parts of it, may not
 * be reproduced or transmitted in any form, including reprinting,
 * photocopying or microfilming, or by any means, electronic,
 * mechanical or otherwise, or stored in a retrieval system,
 * or used for any purpose, without the prior written permission
 * of ACE Associated Computer Experts bv.
 * This source file is derived from UNIX System 5.0 (Copyright AT&T)
 *
 * (c) 1985 ACE Associated Computer Experts bv, Amsterdam
 *
 */

/*		COMMON ARCHIVE FORMAT
 *
 *	ARCHIVE File Organization:
 *	_______________________________________________
 *	|__________ARCHIVE_MAGIC_STRING_______________|
 *	|__________ARCHIVE_FILE_MEMBER_1______________|
 *	|					      |
 *	|	Archive File Header "ar_hdr"          |
 *	|.............................................|
 *	|	Member Contents			      |
 *	|		1. External symbol directory  |
 *	|		2. Text file		      |
 *	|_____________________________________________|
 *	|________ARCHIVE_FILE_MEMBER_2________________|
 *	|		"ar_hdr"		      |
 *	|.............................................|
 *	|	Member Contents (.o or text file)     |
 *	|_____________________________________________|
 *	|	.		.		.     |
 *	|	.		.		.     |
 *	|	.		.		.     |
 *	|_____________________________________________|
 *	|________ARCHIVE_FILE_MEMBER_n________________|
 *	|		"ar_hdr"		      |
 *	|.............................................|
 *	|		Member Contents 	      |
 *	|_____________________________________________|
 *
 */

#define ARMAG	"!<arch>\n"
#define SARMAG	8
#define ARFMAG	"`\n"

struct ar_hdr		/* archive file member header - printable ascii */
{
	char	ar_name[16];	/* file member name - `/' terminated */
	char	ar_date[12];	/* file member date - decimal */
	char	ar_uid[6];	/* file member user id - decimal */
	char	ar_gid[6];	/* file member group id - decimal */
	char	ar_mode[8];	/* file member mode - octal */
	char	ar_size[10];	/* file member size - decimal */
	char	ar_fmag[2];	/* ARFMAG - string to end header */
};

#define ARSZ	(16 + 12 + 6 + 6 + 8 + 10 + 2)

#endif /* AR_H */
