/*	@ (#)inet.h 1.7 88/02/07 SMI; from UCB 5.1 5/30/85 */
/*
 * SccsId: @(#)inet.h	1.3	2/1/93	
 */

#ifndef _INET_H_
#define _INET_H_	1

#include <sys/types.h>
#include <netinet/in.h>

/*
 *   External definitions for functions in inet(3N).
 *
 *   The routines inet_addr() and inet_network()  each  interpret
 *   character  strings  representing  numbers  expressed  in the
 *   Internet standard `.' notation, returning  numbers  suitable
 *   for  use as Internet addresses and Internet network numbers,
 *   respectively.  The routine inet_makeaddr() takes an Internet
 *   network number and a local network address and constructs an
 *   Internet address from it.   The  routines  inet_netof()  and
 *   inet_lnaof()  break apart Internet host addresses, returning
 *   the network number and local network address  part,  respec-
 *   tively.
 *
 *   The routine inet_ntoa() returns a pointer to a string in the
 *   base 256 notation ``d.d.d.d'' described below.
 *
 *   All Internet address are returned in  network  order  (bytes
 *   ordered  from left to right).  All network numbers and local
 *   address parts are returned as machine format integer values.
 */

ulong	       inet_addr(char *cp);
char	      *inet_ntoa(struct in_addr in);
struct in_addr inet_makeaddr(int net, int lna);
ulong          inet_network(char *cp);
ulong          inet_netof(struct in_addr in);
ulong          inet_lnaof(struct in_addr in);

#endif
