# ifndef AUX_H
# define AUX_H

/*
 * SCCS:	@(#)aux.h	92.1	92/12/09	(c) ACE
 *
 * This source file is part of the ACE Compiler Family.
 * Copyright reserved. This source file, or parts of it, may not
 * be reproduced or transmitted in any form, including reprinting,
 * photocopying or microfilming, or by any means, electronic,
 * mechanical or otherwise, or stored in a retrieval system,
 * or used for any purpose, without the prior written permission
 * of ACE Associated Computer Experts bv.
 *
 * (c) 1985 ACE Associated Computer Experts bv, Amsterdam
 *
 * Author: Duk Bekema (LJB).
 *
 */

#ifndef ISNON
#define ISNON(x)  (((x) & N_TMASK) == (DT_NON << N_BTSHFT))
#endif /* not ISNON */

#ifndef ushort
#define ushort	unsigned short
#endif /* not ushort */

#define MAXAUXENT	1

/*
 * Types of aux entries.
 */
#define AUX_ERR	(-1)
#define AUX_FIL	0
#define AUX_SCN	1
#define AUX_TAG	2
#define AUX_BIT	3
#define AUX_EOS	4
#define AUX_FCN	5
#define AUX_ARR	6
#define AUX_EBF	7
#define AUX_BOB	8
#define AUX_STR	9

/*
 * Lderrno values.
 */
#define X_SERIOUS	(-1)
#define X_MISSING	(-2)
#define X_TOOMANY	(-3)

struct aux {
	ushort	xx_typ;
	union {
		/* xx_typ is AUX_FIL */
		struct {
			char	xx__filnam[FILNMLEN];
		} xx__fil;

		/* xx_typ is AUX_SCN */
		struct {
			long	xx__scnlen;
			ushort	xx__scnrel;
			ushort	xx__scnnln;
		} xx__scn;

		/* xx_typ is AUX_TAG */
		struct {
			ushort	xx__tagsiz;
			long	xx__tagend;
		} xx__tag;

		/* xx_typ is AUX_BIT */
		struct {
			ushort	xx__bitwid;
		} xx__bit;

		/* xx_typ is AUX_EOS */
		struct {
			long	xx__eostag;
			ushort	xx__eossiz;
		} xx__eos;

		/* xx_typ is AUX_FCN */
		struct {
			long	xx__fcntag;
			long	xx__fcnsiz;
			long	xx__fcnlnp;
			long	xx__fcnend;
			ushort	xx__fcnvec;
		} xx__fcn;

		/* xx_typ is AUX_ARR */
		struct {
			long	xx__arrtag;
			ushort	xx__arrlin;
			ushort	xx__arrsiz;
			ushort	xx__arrdim[DIMNUM];
		} xx__arr;

		/* xx_typ is AUX_EBF */
		struct {
			ushort	xx__ebflin;
		} xx__ebf;

		/* xx_typ is AUX_BOB */
		struct {
			ushort	xx__bbflin;
			long	xx__bbfend;
		} xx__bbf;

		/* xx_typ is AUX_STR */
		struct {
			long	xx__strtag;
			ushort	xx__strsiz;
		} xx__str;
	} xx_u;
};

typedef struct aux	AUX;

#define xx_fil xx_u.xx__fil
#define xx_filnam xx_fil.xx__filnam

#define xx_scn xx_u.xx__scn
#define xx_scnlen xx_scn.xx__scnlen
#define xx_scnrel xx_scn.xx__scnrel
#define xx_scnnln xx_scn.xx__scnnln

#define xx_tag xx_u.xx__tag
#define xx_tagsiz xx_tag.xx__tagsiz
#define xx_tagend xx_tag.xx__tagend

#define xx_bit xx_u.xx__bit
#define xx_bitwid xx_bit.xx__bitwid

#define xx_eos xx_u.xx__eos
#define xx_eostag xx_eos.xx__eostag
#define xx_eossiz xx_eos.xx__eossiz

#define xx_fcn xx_u.xx__fcn
#define xx_fcntag xx_fcn.xx__fcntag
#define xx_fcnsiz xx_fcn.xx__fcnsiz
#define xx_fcnlnp xx_fcn.xx__fcnlnp
#define xx_fcnend xx_fcn.xx__fcnend
#define xx_fcnvec xx_fcn.xx__fcnvec

#define xx_arr xx_u.xx__arr
#define xx_arrtag xx_arr.xx__arrtag
#define xx_arrlin xx_arr.xx__arrlin
#define xx_arrsiz xx_arr.xx__arrsiz
#define xx_arrdim xx_arr.xx__arrdim

#define xx_ebf xx_u.xx__ebf
#define xx_ebflin xx_ebf.xx__ebflin

#define xx_bbf xx_u.xx__bbf
#define xx_bbflin xx_bbf.xx__bbflin
#define xx_bbfend xx_bbf.xx__bbfend

#define xx_str xx_u.xx__str
#define xx_strtag xx_str.xx__strtag
#define xx_strsiz xx_str.xx__strsiz

#define xx_err xx_u.xx__err
#define xx_errlin xx_err.xx__errlin
# endif /* AUX_H */
