#ifndef _CTYPE_H
#define _CTYPE_H

/*
 * @(#)ctype.h	92.1 92/12/09
 *
 * (c) 1985 ACE	Associated Computer Experts bv,
 *		Amsterdam,
 *		The Netherlands.
 */

#define	_U	01	/* Upper case */
#define	_L	02	/* Lower case */
#define	_N	04	/* Numeral (digit) */
#define	_S	010	/* Spacing character */
#define	_P	020	/* Punctuation */
#define	_C	040	/* Control character */
#define	_B	0100	/* Blank */
#define	_X	0200	/* heXadecimal digit */

#ifdef __STDC__

int isalnum(int _c);		/* alphanumeric [a-z], [A-Z], [0-9] */
int isalpha(int _c);		/* alphabetic */
int iscntrl(int _c);		/* control characters */
int isdigit(int _c);		/* digit [0-9] */
int isgraph(int _c);		/* graphic character */
int islower(int _c);		/* lower-case letter [a-z] */
int isprint(int _c);		/* printable character */
int ispunct(int _c);		/* punctuation mark */
int isspace(int _c);		/* white space sp, \f, \n, \r, \t, \v */
int isupper(int _c);		/* upper-case letter [A-Z] */
int isxdigit(int _c);		/* hex digit [0-9], [a-f], [A-F] */
int tolower(int _c);		/* convert to lower case character */
int toupper(int _c);		/* convert to upper case character */

#else	/* !__STDC__ */

extern int isalnum();		/* alphanumeric [a-z], [A-Z], [0-9] */
extern int isalpha();		/* alphabetic */
extern int isascii();		/* ascii char */
extern int iscntrl();		/* control characters */
extern int isdigit();		/* digit [0-9] */
extern int isgraph();		/* graphic character */
extern int islower();		/* lower-case letter [a-z] */
extern int isprint();		/* printable character */
extern int ispunct();		/* punctuation mark */
extern int isspace();		/* white space sp, \f, \n, \r, \t, \v */
extern int isupper();		/* upper-case letter [A-Z] */
extern int isxdigit();		/* hex digit [0-9], [a-f], [A-F] */
extern int tolower();		/* convert to lower case character */
extern int toupper();		/* convert to upper case character */

#endif	/* __STDC__ */

#ifndef lint

extern unsigned char _ctype[];
extern int __ctype_tmp;

#define	isalpha(c)	((_ctype + 1)[c] & (_U | _L))
#define	isupper(c)	((_ctype + 1)[c] & _U)
#define	islower(c)	((_ctype + 1)[c] & _L)
#define	isdigit(c)	((_ctype + 1)[c] & _N)
#define	isxdigit(c)	((_ctype + 1)[c] & _X)
#define	isalnum(c)	((_ctype + 1)[c] & (_U | _L | _N))
#define	isspace(c)	((_ctype + 1)[c] & _S)
#define	ispunct(c)	((_ctype + 1)[c] & _P)
#define	isprint(c)	((_ctype + 1)[c] & (_P | _U | _L | _N | _B))
#define	isgraph(c)	((_ctype + 1)[c] & (_P | _U | _L | _N))
#define	iscntrl(c)	((_ctype + 1)[c] & _C)

#define toupper(c)	(__ctype_tmp = (c), \
	islower(__ctype_tmp) ? __ctype_tmp - 'a' + 'A' : __ctype_tmp)
#define tolower(c)	(__ctype_tmp = (c), \
	isupper(__ctype_tmp) ? __ctype_tmp - 'A' + 'a' : __ctype_tmp)

#ifndef __STDC__
#define	_toupper(c)	((c) - 'a' + 'A')
#define	_tolower(c)	((c) - 'A' + 'a')
#define	isascii(c)	(!((c) & ~0177))
#define	toascii(c)	((c) & 0177)
#endif

#endif /* lint */

#endif /* _CTYPE_H */
