#ifndef	DIRENT_H
#define	DIRENT_H

/*
 * SCCS-info: @(#)dirent.h	92.1 92/12/09 (c) ACE
 *
 * (c) 1987 ACE	Associated Computer Experts bv,
 *		Amsterdam,
 *		The Netherlands.
 */

/*
 * Size of chunks by which directories are read, chosen to
 * read > 95 % of directories on a "typical" file system
 * in one go.
 * Must be greater than or equal to STD_BLK.
 */
#define	DIRBLKSIZ	2048

/* Defined only if this file has been included from ndir.h */
#ifdef	direct
/*
 * Size of directory entry "dp".  For compatibilty with
 * Berkeley systems this macro should be used, rather
 * than "sizeof(struct dirent)".
 */
#define	MAXNAMLEN	NAME_MAX
#undef	DIRSIZ
#define	DIRSIZ(dp)	(sizeof(struct dirent))
#endif	/* direct */

typedef struct {		/* stream data from opendir() */
	int	dd_fd;			/* file descriptor */
	long	dd_loc;			/* offset in block */
	long	dd_size;		/* amount of valid data */
	char	dd_buf[DIRBLKSIZ];	/* directory data block */
} DIR;

struct dirent {			/* data from getdents() */
	ino_t	d_ino;			/* inode number of entry */
	off_t	d_off;			/* offset of disk directory entry */
	ushort	d_reclen;		/* length of this record */
	ushort	d_namlen;		/* strlen() of d_name */
	char	d_name[NAME_MAX + 1];	/* name of file */
};

void		closedir();
DIR		*opendir();
struct dirent	*readdir();
void		rewinddir();
void		seekdir();
long		telldir();

#endif	DIRENT_H
