/*
 *	@(#)locale.h	92.1	92/12/09	ACE
 *
 *	Localization.
 */

#ifndef _LOCALE_H
#define _LOCALE_H

/*
 *	Note that the implementation for ANSI C is completely different
 *	than that for XPG3.
 */

#ifndef __STDC__

# include	<sys/types.h>

/* Locales are identified by a string.
 * Internally, this is mapped to a locdes_t value.
 */
typedef short	locdes_t;

/* Current index in locale table... */
struct locale
{
	locdes_t	collate;	/* ...for sorting */
	locdes_t	ctype;		/* ...for char types */
	locdes_t	monetary;	/* ...for money */
	locdes_t	numeric;	/* ...for fraction sign */
	locdes_t	time;		/* ...for time/date */
};

struct loctab
{
	char	* name;		/* name of locale */
	char	* awkday [7];	/* abbreviated weekday */
	char	* fwkday [7];	/* full names of weekday */
	char	* amonth [12];	/* abbreviated months */
	char	* fmonth [12];	/* full names of months */
	char	* ampm [2];	/* AM/PM strings */
	char	* datestr;	/* date, strftime() format */
	char	* timestr;	/* time, strftime() format */
	char	fract;		/* sign for fraction */
	char	* coin;		/* string for monetary unit */
};

/* The locale field selections. */
# define	LC_COLLATE	001
# define	LC_CTYPE	002
# define	LC_MONETARY	004
# define	LC_NUMERIC	010
# define	LC_TIME		020
# define	LC_ALL		037

/* Shorthand for decimal point. */
# define	LC_POINT	(_loctab[_curloc.numeric].fract)

extern struct locale	_curloc;
extern struct loctab	_loctab [];
extern char	* setlocale ();

#else /* __STDC__ */

/* $Header: locale.h,v 1.4 90/01/29 10:07:59 eck Exp $ */

struct lconv {
	char	*decimal_point;		/* "." */
	char	*thousands_sep;		/* "" */
	char	*grouping;		/* "" */
	char	*int_curr_symbol;	/* "" */
	char	*currency_symbol;	/* "" */
	char	*mon_decimal_point;	/* "" */
	char	*mon_thousands_sep;	/* "" */
	char	*mon_grouping;		/* "" */
	char	*positive_sign;		/* "" */
	char	*negative_sign;		/* "" */
	char	int_frac_digits;	/* CHAR_MAX */
	char	frac_digits;		/* CHAR_MAX */
	char	p_cs_precedes;		/* CHAR_MAX */
	char	p_sep_by_space;		/* CHAR_MAX */
	char	n_cs_precedes;		/* CHAR_MAX */
	char	n_sep_by_space;		/* CHAR_MAX */
	char	p_sign_posn;		/* CHAR_MAX */
	char	n_sign_posn;		/* CHAR_MAX */
};

#include <null.h>

#define	LC_ALL		1
#define	LC_COLLATE	2
#define	LC_CTYPE	3
#define	LC_MONETARY	4
#define	LC_NUMERIC	5
#define	LC_TIME		6

char	*setlocale(int _category, const char *_locale);
struct lconv	*localeconv(void);

#endif /* __STDC__ */

#endif /* _LOCALE_H */
