#
# defaults for Parix makefiles
#    SccsId:	@(#)parix.mk	1.12	2/1/93
#
# Remarks:  Automatic library update is not possible, because System V 
#	    compilers do not allow to specify tha name of an .o file.
#
#	    The contents of this file was derived from harri's version.
#

SUFFIXES 	= .px .o .c .c~ .s .s~ .S .S~ .f .f~ .F .F~ .l .l~ \
		  .y .y~ .h .h~ .p .p~ .def .def~ .mod .mod~ .x .X .ln

.SUFFIXES:
.SUFFIXES:	$(SUFFIXES)

# OUTPUT_OPTION should be defined to "-o $@" when
# the default rules are used for non-local files.
OUTPUT_OPTION=

BINDIR		= $(PARIX)/bin


#	C language section

CC		= $(BINDIR)/ancc.px
CFLAGS		=
CPPFLAGS	= -DACE
LINT		= lint
LINTFLAGS	=

COMPILE.c	= $(CC) $(CFLAGS) $(CPPFLAGS) -c
LINK.c		= $(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS)
LINT.c		= $(LINT) $(LINTFLAGS) $(CPPFLAGS)

.c:
	$(LINK.c) $< $(LDLIBS) $(CLIBS) -o $@
.c.px:
	$(LINK.c) $< $(LDLIBS) $(CLIBS) -o $@
.c.ln:
	$(LINT.c) $(OUTPUT_OPTION) -i $<
.c.s:	
	$(COMPILE.c) -S $<
.c.o:
	$(COMPILE.c) $<
.c.a:
	$(COMPILE.c) $<
	mv `basename $<`.o $%
	$(AR.a) $@ $%
	$(RM) $%

# 	C language section, yacc

YACC		= yacc
YFLAGS		=
YACC.y		= $(YACC) $(YFLAGS)

.y:
	$(YACC.y) $<
	$(LINK.c) y.tab.c $(LDLIBS) $(CLIBS) -o $@
	$(RM) y.tab.[co]
.y.px:
	$(YACC.y) $<
	$(LINK.c) y.tab.c $(LDLIBS) $(CLIBS) -o $@
	$(RM) y.tab.[co]
.y.c:
	$(YACC.y) $<
	mv y.tab.c $@
.y.ln:
	$(YACC.y) $<
	$(LINT.c) -o $@ -i y.tab.c
	$(RM) y.tab.c
.y.o:
	$(YACC.y) $<
	$(COMPILE.c) y.tab.c
	mv y.tab.o $@
	$(RM) y.tab.c


#	C language section, lex

LEX		= lex
LFLAGS		=
LEX.l		= $(LEX) $(LFLAGS)

.l:
	$(RM) $*.c
	$(LEX.l) $< > $*.c
	$(LINK.c) $*.c -ll $(LDLIBS) $(CLIBS) -o $@
	$(RM) $*.[co]
.l.px:
	$(RM) $*.c
	$(LEX.l) $< > $*.c
	$(LINK.c) $*.c -ll $(LDLIBS) $(CLIBS) -o $@
	$(RM) $*.[co]
.l.c:
	$(RM) $*.c
	$(LEX.l) $< > $*.c
.l.ln:
	$(RM) $*.c
	$(LEX.l) $< > $*.c
	$(LINT.c) -o $@ -i $*.c
	$(RM) $*.c
.l.o:
	$(RM) $*.c
	$(LEX.l) $< > $*.c
	$(COMPILE.c) $*.c
	$(RM) $*.c


#	FORTRAN section

FC		= $(BINDIR)/f77.px
F77		= $(FC)
FFLAGS		=
FLIBS		=
COMPILE.f	= $(FC) $(FFLAGS) -c
COMPILE.F	= $(FC) $(FFLAGS) $(CPPFLAGS) -c
LINK.f		= $(FC) $(FFLAGS) $(LDFLAGS)
LINK.F		= $(FC) $(FFLAGS) $(CPPFLAGS) $(LDFLAGS)

.f:
	$(LINK.f) $< $(LDLIBS) $(FLIBS) -o $@
.f.px:
	$(LINK.f) $< $(LDLIBS) $(FLIBS) -o $@
.f.s:
	$(COMPILE.f) -S $<
.f.o:
	$(COMPILE.f) $<
.f.a:
	$(COMPILE.f) $<
	mv `basename $<`.o $%
	$(AR.a) $@ $%
	$(RM) $%

.F:
	$(LINK.F) $< $(LDLIBS) $(FLIBS) -o $@
.F.px:
	$(LINK.F) $< $(LDLIBS) $(FLIBS) -o $@
.F.s:
	$(COMPILE.F) -S $<
.F.o:
	$(COMPILE.F) $<
.F.a:
	$(COMPILE.F) $<
	mv `basename $<`.o $%
	$(AR.a) $@ $%
	$(RM) $%

#	Modula-2 section
#
#	to be filled in
#


#	Pascal secton
#
#	to be filled in
#


#	Assembly section

AS		= $(BINDIR)/cc.px
ASFLAGS		= -c
COMPILE.s	= $(AS) $(ASFLAGS)
COMPILE.S	= $(AS) $(ASFLAGS) $(CPPFLAGS)

.s.o:
	$(COMPILE.s) $<
.s.a:
	$(COMPILE.s) $<
	mv `basename $<`.o $%
	$(AR.a) $@ $%
	$(RM) $%

.S.o:
	$(COMPILE.s) $<
.S.a:
	$(COMPILE.S) $<
	mv `basename $<`.o $%
	$(AR.a) $@ $%
	$(RM) $%



#	Linker section

LD		= $(BINDIR)/ld
LDFLAGS		=
LDLIBS		=


#	Library manager

AR		= $(BINDIR)/ar
ARFLAGS		= rv
AR.a		= $(AR) $(ARFLAGS)

.o.a:
	$(AR) $@ $%


#	Miscellaneous section

MAKE		= make
RM		= rm -f
GET		= /usr/sccs/get
GFLAGS		=
SCCSFLAGS	=
SCCSSGETFLAGS	= -s
.SCCS_GET:
	?sccs $(SCCSFLAGS) get $(SCCSGETFLAGS) $@ -G$@


#
# macros when using micromenu files
# (cadese)
#
OEXT		= o
INCL		= -I
OBJC		= -c
LIB		= $(AR)
LIBFLAGS	= $(ARFLAGS)
LINK		= $(LD)

