/*	@ (#)netdb.h 1.10 88/11/08 SMI from UCB 5.9 4/5/88 */
/*
 *	SccsId: @(#)netdb.h	1.4	2/1/93	
 */

#ifndef _NETDB_H_
#define _NETDB_H_	1

#include <sys/types.h>
#include <sys/socket.h>

/*
 * Structures returned by network
 * data base library.  All addresses
 * are supplied in host order, and
 * returned in network order.
 */

struct	hostent {
	char	*h_name;	/* official name of host */
	char	**h_aliases;	/* alias list */
	int	h_addrtype;	/* host address type */
	int	h_length;	/* length of address */
	char	**h_addr_list;	/* list of addresses from name server */
#define	h_addr	h_addr_list[0]	/* address, for backward compatiblity */
};

/*
 * Assumption here is that a network number
 * fits in 32 bits -- probably a poor one.
 */
struct	netent {
	char		*n_name;	/* official name of net */
	char		**n_aliases;	/* alias list */
	int		n_addrtype;	/* net address type */
	unsigned long	n_net;		/* network # */
};

struct	servent {
	char	*s_name;	/* official service name */
	char	**s_aliases;	/* alias list */
	int	s_port;		/* port # */
	char	*s_proto;	/* protocol to use */
};

struct	protoent {
	char	*p_name;	/* official protocol name */
	char	**p_aliases;	/* alias list */
	int	p_proto;	/* protocol # */
};

/*
 *  Function Prototypes
 */
#ifdef	__STDC__
struct hostent  *gethostbyname(char *host);
#ifdef NEVER
struct hostent  *gethostbyaddr(struct addr_in *addr, int len, int type);
struct netent	*getnetbyname(char *name);
struct netent   *getnetbyaddr(long net, int type);
struct servent	*getservbyname(char *name, char *proto);
struct servent  *getservbyport(int port, char *proto);
struct protoent	*getprotobyname(char *name);
struct  protoent *getprotobynumber(int proto);
#endif
#else	/* __STDC__ */
struct hostent  *gethostbyname();
#ifdef NEVER
struct hostent  *gethostbyaddr();
struct netent	*getnetbyname();
struct netent   *getnetbyaddr();
struct servent	*getservbyname();
struct servent  *getservbyport();
struct protoent	*getprotobyname();
struct  protoent *getprotobynumber();
#endif
#endif	/* __STDC__ */

#endif
