/*
 *	@(#)stdlib.h	92.1	92/12/09	ACE
 *
 *	General utilities.
 */

/* $Header: stdlib.h,v 1.5 90/04/23 13:24:33 eck Exp $ */

#ifndef _STDLIB_H
#define	_STDLIB_H

#include <null.h>

#define	EXIT_FAILURE	1
#define	EXIT_SUCCESS	0
#define	RAND_MAX	32767
#define	MB_CUR_MAX	1

typedef struct { int quot, rem; } div_t;
typedef struct { long quot, rem; } ldiv_t;

#include <sys/size_t.h>
#include <sys/wchar_t.h>

#ifdef __STDC__
double		atof(const char *_nptr);
int		atoi(const char *_nptr);
long		atol(const char *_nptr);
double		strtod(const char *_nptr, char **_endptr);
long		strtol(const char *_nptr, char **_endptr, int _base);
unsigned long	strtoul(const char *_nptr, char **_endptr, int _base);
int		rand(void);
void		srand(unsigned int _seed);
void		*calloc(size_t _nmemb, size_t _size);
void		free(void *_ptr);
void		*malloc(size_t _size);
void		*realloc(void *_ptr, size_t _size);
void		abort(void);
int		atexit(void (*_func)(void));
void		exit(int _status);
char		*getenv(const char *_name);
int		system(const char *_string);
void		*bsearch(const void *_key, const void *_base,
			size_t _nmemb, size_t _size,
			int (*_compar)(const void *, const void *));
void		qsort(void *_base, size_t _nmemb, size_t _size,
			int (*_compar)(const void *, const void *));
int		abs(int _j);
div_t		div(int _numer, int _denom);
long		labs(long _j);
ldiv_t		ldiv(long _numer, long _denom);
int		mblen(const char *_s, size_t _n);
int		mbtowc(wchar_t *_pwc, const char *_s, size_t _n);
int		wctomb(char *_s, wchar_t _wchar);
size_t		mbstowcs(wchar_t *_pwcs, const char *_s, size_t _n);
size_t		wcstombs(char *_s, const wchar_t *_pwcs, size_t _n);
#else
extern int	abort(), abs(), atoi(), rand(), srand(), system();
extern double	atof(), strtod();
extern long	atol(), strtol();
extern void	*bsearch(), *calloc(), *getenv(), *malloc(), *realloc();
extern void	exit(), free(), qsort();
#endif

#endif /* _STDLIB_H */
