/*
 *	@(#)string.h	92.1	92/12/09	ACE
 *
 *	String handling.
 */

/* $Header: string.h,v 1.5 90/04/23 13:24:42 eck Exp $ */

#ifndef _STRING_H
#define	_STRING_H

#include <null.h>

#include <sys/size_t.h>

#ifdef __STDC__
void	*memcpy(void *_s1, const void *_s2, size_t _n);
void	*memmove(void *_s1, const void *_s2, size_t _n);
char	*strcpy(char *_s1, const char *_s2);
char	*strncpy(char *_s1, const char *_s2, size_t _n);
char	*strcat(char *_s1, const char *_s2);
char	*strncat(char *_s1, const char *_s2, size_t _n);
int	memcmp(const void *_s1, const void *_s2, size_t _n);
int	strcmp(const char *_s1, const char *_s2);
int	strcoll(const char *_s1, const char *_s2);
int	strncmp(const char *_s1, const char *_s2, size_t _n);
size_t	strxfrm(char *_s1, const char *_s2, size_t _n);
void	*memchr(const void *_s, int _c, size_t _n);
char	*strchr(const char *_s, int _c);
size_t	strcspn(const char *_s1, const char *_s2);
char	*strpbrk(const char *_s1, const char *_s2);
char	*strrchr(const char *_s, int _c);
size_t	strspn(const char *_s1, const char *_s2);
char	*strstr(const char *_s1, const char *_s2);
char	*strtok(char *_s1, const char *_s2);
void	*memset(void *_s, int _c, size_t _n);
char	*strerror(int _errnum);
size_t	strlen(const char *_s);

#else	/* !__STDC__ */

extern char
	*strcpy(),
	*strncpy(),
	*strcat(),
	*strncat(),
	*strchr(),
	*strrchr(),
	*strpbrk(),
	*strstr(),
	*strerror(),
	*strtok();

extern int
	strcmp(),
	strcoll(),
	strncmp(),
	strspn(),
	strcspn(),
	memcmp();

extern size_t
	strlen(),
	strxfrm();

extern void
	*memccpy(),
	*memchr(),
	*memcpy(),
	*memmove(),
	*memset();
#endif /* __STDC__ */

#endif /* _STRING_H */
