/**MO**************************	  Module   *******************************

Name	: comm.h
Purpose	:
Notes	:
SccsId	: @(#)comm.h	1.6	2/1/93	
History : 08.11.91	created  by Saleh, Parsytec
          18.03.92	splitted by Erxleben, Parsytec
          23.03.92      modified by Schneider, Parsytec
	  01.08.92	modified by Saleh/Wagner, Parsytec Aachen
***/

#ifndef _comm_h
#define _comm_h

/**GD************   Global Defines and Data structures	 *****************/

/*
 * message codes
 */
#define CODE_BUILD_LLINK	0x10000000
#define CODE_BUILD_VLINK	0x10000001
#define CODE_RC_SENDER		0x10000002
#define CODE_RC_RECEIVER	0x10000003


/**DF********************   Declared Functions	 *************************/

#ifdef __STDC__

extern int      Send (int TopId, int LogLinkId, void *Data, int Size);
extern int      Recv (int TopId, int LogLinkId, void *Data, int Size);

extern int      AInit (int TopId, int Threads, int Size);
extern int	AExit (int Top_Id);
extern int      ASend
                (int TopId, int LogLinkId, void *Data, int Size, int *Result);
extern int      ARecv
                (int TopId, int LogLinkId, void *Data, int size, int *Result);
extern int      ASync (int TopId, int LogLinkId);
extern int      AInfo (int TopId, int LogLinkId);

extern int      SendNode (int ProcId, int ReqId, void * Buffer, int Size);
extern int      RecvNode (int ProcId, int ReqId, void * Buffer, int Size);

#else

extern int      Send ();
extern int      Recv ();

extern int      AInit ();
extern int	AExit ();
extern int      ASend ();
extern int      ARecv ();
extern int      ASync ();
extern int      AInfo ();

extern int      SendNode ();
extern int      RecvNode ();

#endif					/* __STDC__ */

#endif					/* _comm_h */

/*** end of comm.h ***/
