/**MO************************************************************

Name	: debug.h
Purpose	:
Notes	:
SccsId	: @(#)debug.h	1.3	2/1/93	
History	: 25.11.91	created  by Erxleben, Parsytec
	  09.12.91	modified by Erxleben, Parsytec
	  13.12.91	modified by Erxleben, Parsytec
	  18.12.91	reworked by Fleischer, Parsytec
	  24.01.92	modified by Erxleben, Parsytec
	  30.01.92	modified by Erxleben, Parsytec
	  12.02.92	modified by Erxleben, Parsytec (ACE)

***/

#ifndef	_debug_h_
#define	_debug_h_

/**GD************   Global Defines and Data structures   *****************/

#define	MAX_BREAK_PATCH_SIZE	8

/*
 *	Run status of a stopped thread
 */

#define	NO_BREAK	0
#define	RUNNING		1
#define	SINGLESTEP	2
#define	INTERPRETE	3
#define	STOPPED		4
#define	RUNABLE		5
#define	TIMESLEEP0	6
#define	TIMESLEEP1	7
#define	CHANNELSLEEP	8

/* return codes from StopThread */

#define	STOP_THREAD_OK		0	/* no errors */
#define	STOP_THREAD_EINVAL	-1	/* thread dont' exists */
#define	STOP_THREAD_ENXIO	-2	/* cant' found this thread */

typedef struct {
    Semaphore_t     BreakSem;
    List_t          BreakList;
    void            (*DebugHandlerAdr) ();
}               RootDebug_t;

typedef struct ThreadStatus {
    int             RunStatus;
    int             Wptr;
    int             Iptr;
    int             Areg, Breg, Creg;
    double          FAreg, FBreg, FCreg;
}               ThreadStatus_t;

typedef struct DebugPushStruct {
    Node_t          myNode;
    double          FAreg, FBreg, FCreg;
    int             Wptr;
    int             DebugFlag;
    int             old_prio, s[2];	/* used by MY_CHANGE_PRIORITY */
}               DebugPushStruct_t;

/**DF********************   Declared Functions   *************************/

#ifdef	__STDC__

extern int      SetBreak (byte *, byte *);
extern int      ClearBreak (byte *, byte *);
extern Thread_t *WaitBreak (ThreadStatus_t *);
extern int      ContinueBreak (Thread_t *, ThreadStatus_t *);
extern int      StepThread (Thread_t *, ThreadStatus_t *, int);
extern void     DebugHandler (int, int, int);
extern int      InitDebugRoot (void);

#else

extern int      SetBreak ();
extern int      ClearBreak ();
extern Thread_t *WaitBreak ();
extern int      ContinueBreak ();
extern int      StepThread ();
extern void     DebugHandler ();
extern int      InitDebugRoot ();

#endif					/* __STDC__ */

#endif					/* _debug_h_ */

/*** end of debug.h ***/
