/**MO**************************   Module   *******************************

Name	: sys/errcodes.h
Purpose	: definition of the Parix error codes
Notes	: this file is automatically generated from error.ecodes
	  This file is included by errno.h
SccsId	: @(#)errcodes.h.awk	1.2	2/1/93	

***/

#ifndef	_errcodes_h_
#define	_errcodes_h_

/**GD************   Global Defines and Data structures   *****************/

#define MIN_ERRNO	-3
#define MAX_ERRNO	103

#define	NO_ERROR	0		/* No error */
#define	EPERM		1		/* Operation not permitted */
#define	ENOENT		2		/* No such file or directory */
#define	ESRCH		3		/* No such process */
#define	EINTR		4		/* Interrupted system call */
#define	EIO		5		/* Input/Output error */
#define	ENXIO		6		/* No such device or address */
#define	E2BIG		7		/* Argument list too long */
#define	ENOEXEC		8		/* Exec format error */
#define	EBADF		9		/* Bad file number */
#define	ECHILD		10		/* No child processes */
#define	EAGAIN		11		/* Resource temporarily unavailable */
#define	ENOMEM		12		/* Not enough space */
#define	EACCES		13		/* Permission denied */
#define	EFAULT		14		/* Bad address */
#define	ENOTBLK		15		/* Block device required */
#define	EBUSY		16		/* Resource busy */
#define	EEXIST		17		/* File exists */
#define	EXDEV		18		/* Improper link */
#define	ENODEV		19		/* No such device */
#define	ENOTDIR		20		/* Not a directory */
#define	EISDIR		21		/* Is a directory */
#define	EINVAL		22		/* Invalid argument */
#define	ENFILE		23		/* Too many open files in the system */
#define	EMFILE		24		/* Too many open files in a process */
#define	ENOTTY		25		/* Inappropriate I/O control operation */
#define	ETXTBSY		26		/* Text file busy */
#define	EFBIG		27		/* File too large */
#define	ENOSPC		28		/* No space left on device */
#define	ESPIPE		29		/* Illegal seek */
#define	EROFS		30		/* Read only file system */
#define	EMLINK		31		/* Too many links to same file */
#define	EPIPE		32		/* Broken pipe */
#define	EDOM		33		/* Domain error */
#define	ERANGE		34		/* Math result not representable */
#define	ENOMSG		35		/* No message of desired type */
#define	EIDRM		36		/* Identifier removed */
#define	ECHRNG		37		/* Channel number out of range */
#define	EL2NSYNC	38		/* Level 2 not synchronized */
#define	EL3HLT		39		/* Level 3 halted */
#define	EL3RST		40		/* Level 3 reset */
#define	ELNRNG		41		/* Link number out of range */
#define	EUNATCH		42		/* Protocol driver not attached */
#define	ENOCSI		43		/* No CSI structure available */
#define	EL2HLT		44		/* Level 2 halted */
#define	EDEADLK		45		/* Resource deadlock would occur */
#define	ENOLCK		46		/* No locks available */
#define	ENOTSOCK	47		/* Socket operation on non-socket */
#define	EDESTADDRREQ	48		/* Destination address required */
#define	EMSGSIZE	49		/* Message too long */
#define	EPROTOTYPE	50		/* Protocol wrong type for socket */
#define	ENOPROTOOPT	51		/* Protocol not available */
#define	EPROTONOSUPPORT	52		/* Protocol not supported */
#define	ESOCKTNOSUPPORT	53		/* Socket type not supported */
#define	EOPNOTSUPP	54		/* Operation not supported on socket */
#define	EPFNOSUPPORT	55		/* Protocol family not supported */
#define	EAFNOSUPPORT	56		/* Address family not supported */
#define	EADDRINUSE	57		/* Address already in use */
#define	EADDRNOTAVAIL	58		/* Cannot assign requested address */
#define	ENETDOWN	59		/* Network is down */
#define	ENETUNREACH	60		/* Network is unreachable */
#define	ENETRESET	61		/* Network dropped connection on reset */
#define	ECONNABORTED	62		/* Software caused connection abort */
#define	ECONNRESET	63		/* Connection reset by peer */
#define	ENOBUFS		64		/* No buffer space available */
#define	EISCONN		65		/* Socket is already connected */
#define	ENOTCONN	66		/* Socket is not connected */
#define	ESHUTDOWN	67		/* Cannot send after socket shutdown */
#define	ETOOMANYREFS	68		/* Too many references: cannot splice */
#define	ETIMEDOUT	69		/* Connection timed out */
#define	ECONNREFUSED	70		/* Connection refused */
#define	EHOSTDOWN	71		/* Host is down */
#define	EHOSTUNREACH	72		/* No route to host */
#define	EALREADY	73		/* Operation already in progress */
#define	EINPROGRESS	74		/* Operation now in progress */
#define	ENAMETOOLONG	75		/* Filename too long */
#define	ENOTEMPTY	76		/* Directory not empty */
#define	ENOSYS		77		/* Function not implemented */

#define	DS_NO_ERROR	0		/* No error */
#define	DS_EAGAIN	-1		/* Communication error, try again */
#define	DS_ELIB		-2		/* No such library */
#define	DS_EFUNC	-3		/* No such function */

#define	EECODE		100		/* Unknown host error code */
#define	ESERVER		101		/* Incompatible Server */
#define	ECOMM		102		/* Communiation failure */
#define	TEST		103		/* PARIX Test code */

#endif					/* _errcodes_h_ */

/*** end of errcodes.h ***/
