#ifndef FCNTL_H
#define FCNTL_H

/*
 * SCCS-info: @(#)fcntl.h	92.1 92/12/09 (c) ACE
 *
 * (c) 1985 ACE	Associated Computer Experts bv,
 *		Amsterdam,
 *		The Netherlands.
 */

#include <sys/types.h>

/* Flag values accessible to open(2) and fcntl(2) */
/*  (The first three can only be set by open) */
#define	O_RDONLY 0
#define	O_WRONLY 1
#define	O_RDWR	 2
#define	O_NDELAY 04	/* Non-blocking I/O */
#define	O_APPEND 010	/* append (writes guaranteed at the end) */
#define O_SYNC	020	/* Synchronous write option.			*/

/* Flag values accessible only to open(2) */
#define	O_CREAT	00400	/* open with file create (uses third open arg)*/
#define	O_TRUNC	01000	/* open with truncation */
#define	O_EXCL	02000	/* exclusive open */

/* fcntl(2) requests */
#define	F_DUPFD	0	/* Duplicate fildes */
#define	F_GETFD	1	/* Get fildes flags */
#define	F_SETFD	2	/* Set fildes flags */
#define	F_GETFL	3	/* Get file flags */
#define	F_SETFL	4	/* Set file flags */
#define F_GETLK	5	/* Get blocking file locks.			*/
#define F_SETLK	6	/* Set or clear file locks and fail on busy.	*/
#define F_SETLKW 7	/* Set or clear file locks and wait on busy.	*/

/* File segment locking control structure.				*/
struct flock {
	short	l_type;		/* Type of file.			*/
	short	l_whence;	/* Starting offset.			*/
	long	l_start;	/* Relative offset.			*/
	long	l_len;		/* If 0 then until EOF.			*/
	short	l_pid;		/* Returned with F_GETLK.		*/
};

/* File segment locking types.						*/
#define	F_RDLCK	01	/* Read lock.					*/
#define	F_WRLCK	02	/* Write lock.					*/
#define	F_UNLCK	03	/* Remove lock(s).				*/

#ifdef __STDC__

int creat (char *_path, mode_t _mode);
int fcntl (int _fildes, int _cmd, ...);
int open (char *_path, int _oflag, ...);

#else /* !__STDC__ */

int creat ();
int fcntl ();
int open ();

#endif /* __STDC__ */

#endif
