/**MO**************************   Module   *******************************

Name	: link.h
Purpose	:
Notes	:
SccsId	: @(#)link.h	1.5	2/1/93	
History : 04.09.91	created by Nowak, Parsytec
	  15.04.92	modified by Nowak, 2. link semaphore added

***/

#ifndef _link_h_
#define _link_h_

/**HE*************************   Headers   *******************************/

#include <sys/sem.h>
#include <sys/context.h>
#include <sys/types.h>

/**GD************   Global Defines and Data structures   *****************/

#define CHAN_INIT(ChannelP)   (*(ChannelP) = (Channel_t)MININT)

#define INLINK(Link)  (((Channel_t *)MININT)+((Link)+NO_OF_LINKS))
#define OUTLINK(Link) (((Channel_t *)MININT)+(Link))


/*
 * structure of a link control block
 */

typedef struct {
    Semaphore_t     SendLock;
    Semaphore_t     RecvLock;
    Context_t      *Owner;
    Channel_t      *Send;
    Channel_t      *Recv;
}               LinkCB_t;


/**DF********************   Declared Functions   *************************/

#ifdef __STDC__
extern LinkCB_t *MakeLink (int, int, int *);
extern LinkCB_t *GetLink (int, int, int *);
extern LinkCB_t *ConnectLink (int, int, int *);
extern int      BreakLink (LinkCB_t *);

extern int      SendLink (LinkCB_t *, void *, int);
extern int      RecvLink (LinkCB_t *, void *, int);

#else

extern LinkCB_t *MakeLink ();
extern LinkCB_t *GetLink ();
extern LinkCB_t *ConnectLink ();
extern int      BreakLink ();

extern int      SendLink ();
extern int      RecvLink ();

#endif					/* __STDC__ */

#endif					/* _link_h_ */

/*** end of link.h ***/
