/**MO**************************   Module   *******************************

Name	: list.h
Purpose	:
Notes	:
SccsId	: @(#)list.h	1.5	2/1/93	
History	: 13.09.91	created by Nowak, Parsytec

***/

#ifndef _list_h_
#define _list_h_


/**GD************   Global Defines and Data structures   *****************/

/*
 * structure of a list node
 */

typedef struct Node {
    struct Node    *Next;
    struct Node    *Prev;
}               Node_t;

/*
 * structure of the list root
 */

typedef struct {
    Node_t         *Head;
    Node_t         *Null;
    Node_t         *Tail;
}               List_t;
/**DF********************   Declared Functions   *************************/

#ifdef __STDC__


/*
 * a Listfunction
 */

typedef int     (*ListFunc_t) (Node_t *,...);


extern void     InitList (List_t *);
extern void     AddHead (List_t *, Node_t *);
extern void     AddTail (List_t *, Node_t *);
extern void     PreInsert (Node_t *, Node_t *);
extern void     PostInsert (Node_t *, Node_t *);
extern Node_t  *Remove (Node_t *);
extern Node_t  *RemHead (List_t *);
extern Node_t  *RemTail (List_t *);
extern Node_t  *SearchList (List_t *, ListFunc_t fn,...);
extern int      WalkList (List_t *, ListFunc_t fn,...);

#else

extern void     InitList ();
extern void     AddHead ();
extern void     AddTail ();
extern void     PreInsert ();
extern void     PostInsert ();
extern Node_t  *Remove ();
extern Node_t  *RemHead ();
extern Node_t  *RemTail ();
extern Node_t  *SearchList ();
extern int      WalkList ();

/*
 * a Listfunction
 */

typedef int     (*ListFunc_t) ();


#endif					/* __STDC__ */

#endif					/* _list_h_ */

/*** end of list.h ***/
