/**MO**************************	  Module   *******************************

Name	: logerror.h
Purpose	: header for error logging routines
Notes	:
SccsId	: @(#)logerror.h	1.6	2/19/93	
History	: 03.10.91	created by Saleh, Parsytec

***/

#ifndef _logerror_h_
#define _logerror_h_

#include <stdarg.h>

/**GD************   Global Defines and Data structures	 *****************/

#define EC_MASK	 0xF0000000
#define EC_FATAL 0xE0000000
#define EC_CRIT	 0xD0000000
#define EC_ERROR 0xC0000000
#define EC_WARN	 0xB0000000
#define EC_DEBUG 0xA0000000
#define EC_INFO	 0x90000000
#define	EC_MESS	 0x80000000

typedef struct {
    Semaphore_t     Lock;
    char            Text[1024];
    char            Fmt[256];
}               RootLogger_t;

/**XF*********************   Declared Functions	 **************************/

#ifdef	__STDC__
extern int	vsprintd (char *Buffer, int BufSize, 
			  char *Format, va_list args);
extern int	sprintd (char *Buffer, int BufSize, 
			 char *Format, ...);
extern void	printd (char *Format, ...);
extern void	printe (char *Format, ...);
extern void     LogError (int ErrCode, char *FName, char *Format,...);

#else

extern int	vsprintd ();
extern int	sprintd ();
extern void	printd ();
extern void	printe ();
extern void     LogError ();

#endif					/* __STDC__ */

#endif					/* _logerror_h_ */

/*** end of logerror.h ***/
