/**MO************************************************************

Name	: profile.h
Purpose	:
Notes	:
SccsId	: @(#)profile.h	1.4	2/1/93	
History	: 09.12.92	created by Fleischer, Parsytec Aachen

***/

#ifndef _profile_h_
#define _profile_h_

/**HE*************************   Headers   *******************************/

#include <sys/types.h>
#include <sys/list.h>
#include <sys/sem.h>

/**GD************   Global Defines and Data structures   *****************/

/* 
 * interval (sleep time) between two samples in microseconds
 */

#define	SAMPLE_INTERVAL	20000

/* profiling node for each context */

typedef struct {
    Node_t	node;			/* queueing node		 */
    ushort	*buf;			/* sampling buffer		 */
    int		bufcnt;			/* entries in sampling buffer 	 */
    uint	offset;			/* PC offset (to be subtracted)	 */
    uint	scale;			/* divider			 */
} ProfNode_t;

/* profiling anchor in the Root structure */
typedef struct {
    Semaphore_t	Lock;			/* structure access lock	*/
    Semaphore_t	Wait;			/* waitpoint for sampler if	*/
    					/* sampling is not necessary	*/
    int		Count;			/* number of nodes in the list	*/
    List_t	List;			/* list of ProfNodes		*/
}               RootProfile_t;

#endif					/* _profile_h_ */

/*** end of profile.h ***/
