/**MO**************************   Module   *******************************

Name	: rlink.h
Purpose	:
Notes	:
SccsId	: @(#)rlink.h	1.3	2/1/93	
History	: 04.09.91	created by Nowak, Parsytec
          26.11.91	modified by Wassew, Parsytec
	  17.12.91	rejoined by Fleischer, Parsytec
          18.02.92	modified by Wassew, Parsytec

***/

#ifndef _rlink_h_
#define _rlink_h_

/**GD************   Global Defines and Data structures   *****************/

/*
 * resource data structure (see t9000 manual)
 */

typedef struct {
    int             RDSf;
    int             RDSb;
    int             RDSpw;
}               RDS_t;

/*
 * structure of a service control block
 */

typedef struct {
    int             ServiceId;
    Context_t      *Owner;
    void           *RDSf;
    void           *RDSb;
    Channel_t       RDSpw;
    Thread_t       *Thread;
    Semaphore_t	    Sem;
}               ServiceCB_t;

/*
 * structure of a resource link
 */

typedef struct {
    ServiceCB_t    *Server;
    Channel_t       AckChan;
    Channel_t       ReqChan;
    void           *RCptr;
    int             RCid;
}               RLink_t;


/**DF********************   Declared Functions   *************************/

#ifdef __STDC__
extern int      AllocRLink (void);
extern int      FreeRLink (int);

extern ServiceCB_t *InitService (int, int *);
extern LinkCB_t *ConnectService (int, int, int *);
extern int      DisconnectService (int, int, LinkCB_t *);
extern LinkCB_t *GrantService (ServiceCB_t *, int *);
extern int      UnGrantService (ServiceCB_t *, LinkCB_t *);
extern int      FreeService (ServiceCB_t *);

#else

extern int      AllocRLink ();
extern int      FreeRLink ();

extern ServiceCB_t *InitService ();
extern LinkCB_t *ConnectService ();
extern int      DisconnectService ();
extern LinkCB_t *GrantService ();
extern int      UnGrantService ();
extern int      FreeService ();

#endif					/* __STDC__ */

#endif					/* _rlink_h_ */

/*** end of rlink.h ***/
