/**MO**************************	  Module   *******************************

Name	: root.h
Purpose	:
Notes	:
SccsId	: @(#)root.h	1.8	2/1/93	
History	: 03.09.91	created by Nowak, Parsytec Chemnitz
          17.12.91	rejoined by Fleischer, Parsytec Aachen
          01.04.92	modified by Erxleben, Parsytec Chemnitz
	  04.08.92	modified by Fleischer, Parsytec Aachen
	  25.08.92	modified by Entgelmeier, Parsytec Aachen
***/


#ifndef _root_h_
#define _root_h_

/**HE*************************	 Headers   *******************************/

#ifdef	__STDC__
#include <stdarg.h>
#endif

#include <sys/param.h>
#include <sys/types.h>
#include <sys/list.h>
#include <sys/sem.h>
#include <sys/thread.h>
#include <sys/context.h>
#include <sys/link.h>
#include <sys/vlink.h>
#include <sys/llink.h>
#include <sys/rlink.h>
#include <sys/select.h>
#include <sys/linkroot.h>
#include <sys/memory.h>
#include <sys/boot.h>
#include <sys/topology.h>
#include <sys/logerror.h>
#include <sys/rrouter.h>
#include <sys/rpc.h>
#include <sys/time.h>
#include <sys/debug.h>
#include <sys/rootcontext.h>
#include <sys/comm.h>
#include <sys/monitor.h>
#include <sys/profile.h>

/**GD************   Global Defines and Data structures	 *****************/

typedef struct {

    RootProc_t     *ProcRoot;		/* boot.h		 */
    RootHosts_t    *HostRoot;		/* boot.h		 */
    RootMemory_t   *MemRoot;		/* memory.h		 */
    RootLink_t     *LinkRoot;		/* linkroot.h		 */
    RootTops_t     *SysTopsRoot;	/* topology.h		 */
    RootTops_t     *UserTopsRoot;	/* -"-			 */
    RootContext_t  *ContextRoot;	/* context.h		 */
    RootMailBox_t  *MailBoxRoot;	/* rrouter.h		 */
    RootLogger_t   *LoggerRoot;		/* logerror.h		 */
    RootDebug_t    *DebugRoot;		/* debug.h		 */
    RootMonitor_t  *MonitorRoot;	/* monitor.h		 */
    RootProfile_t  *ProfileRoot;	/* profile.h		 */
    int            *DummyRoot;

}               RootData_t;


#define GET_ROOT()	((RootData_t *)MEMSTART)
/*
#define FREE_MEM_START	((MEMSTART) + ((NO_OF_LINKS) * 	\
		((LINKIN_GUARD_STACK_SIZE) + (LINKOUT_GUARD_STACK_SIZE))))
#define GET_ROOT()	((RootData_t *)FREE_MEM_START)
*/
#endif					/* _root_h_ */

/*** end of root.h ***/
