/**MO*************************** Module ********************************

Name    :   rootcontext.h
Group   :   exec
Purpose :
Notes   :   common 
SccsId	:   @(#)rootcontext.h	1.3	2/1/93	
History :   13.12.91	created Nowak, Parsytec
            modified Feb/20/92 by Schneider, Parsytec Chemnitz

***/

#ifndef _rootcontext_h_
#define _rootcontext_h_

/**HD************************** Headers *******************************/

#include <sys/list.h>
#include <sys/sem.h>
#include <sys/thread.h>


/**GD************* Global Defines and Data Structures *****************/

/*
 *  root structure for all contexts of one processor
 */
typedef struct {
    int             nContext;       /* Number of contexts             */
    int             LastContext;    /* number of last created context */
    List_t          ContextRoot;    /* List of contexts               */
    int             nCodeCB;        /* Number of CodeCB's in ...      */
                                    /* ... cache table                */
    int             nDummy;         /* Number of removed CodeCB's     */
    CodeCB_t       *CacheTable [CACHE_TABLE_SIZE];
    int             Neighbour [MAX_NEIGHBOURS];
} RootContext_t;

#endif /* _rootcontext_h_ */

/*** end of header rootcontext.h ***/
