/**MO**************************   Module   *******************************

Name	: rpc.h
Purpose	:
Notes	:
SccsId	: @(#)rpc.h	1.3	2/1/93	
History	: 02.10.91	created by Nowak, Parsytec
	  09.10.91	revised by Fleischer, Parsytec
          10.10.91	modified by Fleischer, Parsytec

***/

#ifndef _rpc_h_
#define _rpc_h_

/**GD************   Global Defines and Data structures   *****************/

typedef struct {
    int             LibFunc;
    int             ReplyCSize;
    int             ReplyDSize;
    int             CSize;
    int             DSize;
}               RPC_Request_Header_t;

typedef struct {
    RPC_Request_Header_t Header;
    int            *CVec;
    char           *DVec;
}               RPC_Request_Message_t;

typedef struct {
    int             Result;
    int             CSize;
    int             DSize;
}               RPC_Reply_Header_t;

typedef struct {
    RPC_Reply_Header_t Header;
    int            *CVec;
    char           *DVec;
}               RPC_Reply_Message_t;

#define	CNULL	NULL
#define DNULL	NULL
#define CSNULL	0
#define DSNULL	0
#define CSNONE	(-1)
#define DSNONE	(-1)

#define	InitRequest(req,lfcode,cvec,csize,dvec,rcsize,rdsize) {		 \
    (req)->Header.LibFunc = (lfcode);					 \
    (req)->Header.ReplyCSize = (rcsize);				 \
    (req)->Header.ReplyDSize = (rdsize);				 \
    (req)->Header.CSize = (csize);					 \
    (req)->Header.DSize = 0;						 \
    (req)->CVec = (cvec);						 \
    (req)->DVec = (dvec);						 \
}

#define InitReply(rep,cvec,dvec) {					 \
    (rep)->CVec = (cvec);						 \
    (rep)->DVec = (dvec);						 \
}

#define PutInt(req,val,pos)						 \
    (req)->CVec[(pos)] = (val)

#define GetInt(rep,pos)							 \
    ((rep)->CVec[(pos)])

/**DF********************   Declared Functions   *************************/

#ifdef __STDC__

extern int 	Transaction (HostLinkCB_t *, RPC_Request_Message_t *,
			     RPC_Reply_Message_t *);
extern void     (InitRequest) (RPC_Request_Message_t * Request,
			       int Lib, int Func, int *CVec, int CSize,
			       char *DVec, int ReplyCSize, int ReplyDSize);
extern void     (InitReply) (RPC_Reply_Message_t * Reply,
			                     int *CVec, char *DVec);
extern int 	CheckRetry (HostLinkCB_t * HostLink,
			    RPC_Reply_Message_t * Reply, char *FName);
extern void     (PutInt) (RPC_Request_Message_t * Request, int Val, int Pos);
extern int      (GetInt) (RPC_Reply_Message_t * Reply, int Pos);
extern void     PutString (RPC_Request_Message_t * Request, char *Str,
			   int Ofs);
extern void     PutOpaque (RPC_Request_Message_t * Request, byte * Buf,
			   int Len, int Ofs);
extern void     SwapInts (int *dest, int *source, int size);

#else

extern int      Transaction ();
extern int      CheckRetry ();
extern void     PutString ();
extern void     PutOpaque ();
extern void     SwapInts ();

#endif					/* __STDC__ */

#endif					/* _rpc_h_ */
