/**MO**************************   Module   *******************************

Name	: sem.h
Purpose	:
Notes	:
SccsId	:@(#)sem.h	1.3 	2/1/93	
History	: 13.09.91	created by Nowak, Parsytec Chemnitz
a	  07.01.93	#include added by Fleischer, Parsytec Aachen
***/

#ifndef _semaphore_h_
#define _semaphore_h_

#include <sys/types.h>

/**GD************   Global Defines and Data structures	 *****************/

/*
 *  Every process in the semaphore-queue has a local Variable of the type
 *  Loc_t, where the workspace pointer and a pointer to the next process
 *  are stored.
 */

typedef struct Loc {
    int		    wptr;
    struct Loc	   *next;
}		Loc_t;

/*
 * structure of counting semaphore
 */

typedef struct {
    int		    Count;
    void	   *Head;
    void	   *Tail;
    Channel_t	    Lock;
}		Semaphore_t;


/**DF********************   Declared Functions   *************************/

#ifdef __STDC__

extern void	InitSem (Semaphore_t *, int);
extern void	Wait (Semaphore_t *);
extern void	Signal (Semaphore_t *);
extern int	TestWait (Semaphore_t *);
extern void	WaitFirst (Semaphore_t *);

#else

extern void	InitSem ();
extern void	Wait ();
extern int	TestWait ();
extern void	Signal ();
extern void	WaitFirst ();

#endif					/* __STDC__ */

#endif					/* _semaphore_h_ */

/*** end of sem.h ***/
