/*	@(#)stat.h	92.1    92/12/09	*/

#ifndef STAT_H
#define STAT_H

#include <sys/types.h>

struct	stat
{
	dev_t	st_dev;
	ino_t	st_ino;
	unsigned short st_mode;
	short	st_nlink;
	id_t  	st_uid;
	id_t  	st_gid;
	dev_t	st_rdev;
	off_t	st_size;
	time_t	st_atime;
	time_t	st_mtime;
	time_t	st_ctime;
};

/*	File types	*/
#define	S_IFMT	0170000		/* type of file */
#define		S_IFDIR	0040000	/* directory */
#define		S_IFCHR	0020000	/* character special */
#define		S_IFBLK	0060000	/* block special */
#define		S_IFREG	0100000	/* regular */
#define		S_IFIFO 0010000 /* FIFO special file */
#define		S_IFMPC	0030000	/* multiplexed char special */
#define		S_IFMPB	0070000	/* multiplexed block special */

/*	File modes	*/
#if 0
/* #define	S_ENFMT	0000000		/* record locking enforcement flag */
#endif

#define	S_ISUID	0004000		/* set user id on execution */
#define	S_ISGID	0002000		/* set group id on execution */
#define	S_ISVTX	0001000		/* save swapped text even after use */

#define	S_IRWXU	0000700		/* read, write, execute/search by owner */
#define	S_IRUSR	0000400		/* read permission, owner */
#define	S_IWUSR	0000200		/* write permission, owner */
#define	S_IXUSR	0000100		/* execute permission, owner */

#define	S_IRWXG	0000070		/* read, write, execute/search by group */
#define	S_IRGRP	0000040		/* read permission, group */
#define	S_IWGRP	0000020		/* write permission, group */
#define	S_IXGRP	0000010		/* execute permission, group */

#define	S_IRWXO	0000007		/* read, write, execute/search by others */
#define	S_IROTH	0000004		/* read permission, others */
#define	S_IWOTH	0000002		/* write permission, others */
#define	S_IXOTH	0000001		/* execute permission, others */

#define	S_IREAD	S_IRUSR		/* read permission, owner */
#define	S_IWRITE	S_IWUSR		/* write permission, owner */
#define	S_IEXEC	S_IXUSR		/* execute/search permission, owner */

/*	Macros	*/
#define	S_ISBLK(mode)	(((mode) & S_IFMT) == S_IFBLK)
#define	S_ISCHR(mode)	(((mode) & S_IFMT) == S_IFCHR)
#define	S_ISDIR(mode)	(((mode) & S_IFMT) == S_IFDIR)
#define	S_ISFIFO(mode)	(((mode) & S_IFMT) == S_IFIFO)
#define	S_ISREG(mode)	(((mode) & S_IFMT) == S_IFREG)

#ifdef __STDC__

int	chmod(char *_path, mode_t _mode);
int fstat(int _fildes, struct stat *_buf);
int mkdir(char *_path, mode_t _mode);
int mkfifo(char *_path, mode_t _mode);
int stat(char *_path, struct stat *_buf);
mode_t umask(mode_t _cmask);

#else /* !__STDC__ */

int	chmod();
int fstat();
int mkdir();
int mkfifo();
int stat();
mode_t umask();

#endif /* __STDC__ */

#endif /* STAT_H */
