/**MO************************** Module *********************************

Name	:   thread.h
Purpose :
Notes	:
SccsId	:   @(#)thread.h	1.12	2/1/93	
History :   created Sep/13/91 by Nowak, Parsytec Chemnitz
	    changed Oct/07/91 by Schneider, Parsytec Chemnitz
	    changed Oct/10/91 by Schneider, Parsytec Chemnitz
	    changed Nov/03/91 by Schneider, Parsytec Chemnitz
	    changed Dec/08/91 by Erxleben , Parsytec Chemnitz
	    changed Dec/19/91 by Schneider, Parsytec Chemnitz
	    changed Mar/03/92 by Schneider, Parsytec Chemnitz
	    rejoined Mar/16/92 by Schneider, Parsytec Chemnitz
	    modified Mar/23/92 by Schneider, Parsytec Chemnitz
	    changed Mar/24/92 by Schneider, Parsytec Chemnitz
	    changed May/13/92 by Nowak, Parsytec Chemnitz (longjmp)

***/

#ifndef _thread_h_
#define _thread_h_

/**HE************************* Headers ********************************/

#include <sys/sem.h>
#include <setjmp.h>


/**GD************** Global Defines and Data Structures ****************/

/*
 * MDL Structure
 */
typedef struct {
    int		    Magic;
    byte	   *DataLo;
    byte	   *DataHi;
    byte	   *StackLo;
    byte	   *StackHi;
    byte	   *StackOvfl;
    byte	   *TextLo;
    byte	   *TextHi;
    byte           *StackClass;
}		MDL_t;

/*
 *   unique structure of each thread (in live or zombie state )
 */
typedef struct {
    Node_t	    link;		/* Link in thread list		  */
    MDL_t	    MDL;		/* MDL for ACE runtime modell	  */
    int		    Errno;		/* error code			  */
    int		    Signgam;		/* sign for gamma() result	  */
    int		    status;		/* Buffer for status returned..	  */
					/* ..from thread function	  */
    int		    tsw;		/* Thread status word		  */
    Semaphore_t	    terminate;		/* Signals termination of thread  */
    int		    DebugFlag;		/* for debug information	  */
    int		    DebugWptr;		/* actuell Wptr at break point	  */
    void	   *DebugPtr;
    jmp_buf	    JumpBuf;		/* used for exiting a thread	  */
}		Thread_t;

#define LOW_PRIORITY	  1
#define HIGH_PRIORITY	  0

#define WAIT_THREAD_DONE  1		/* selects bit 0 ...		  */
#define WAIT_ANY_READY	  2		/* ... bit 1 ...		  */
#define ZOMBIE_STATE	  4		/* ... bit 2 of tsw		  */

#define MIN_N_THREAD	  2

#define SetPriority(x)	  ChangePriority(x)
#define GET_PRIORITY(x)	  x = _GetPriority()


/**DF******************* Declared Functions ***************************/

#ifdef __STDC__
extern Thread_t *_RunThread (int (*) (), int, byte *, int *, int,...);
extern Thread_t *StartThread (int (*) (), int, int *, int,...);
extern Thread_t *WaitThread (Thread_t *, void *);
extern Thread_t *GetThreadPtr (void);
extern int	ChangePriority (int);
extern int	_GetPriority (void);

#else

extern Thread_t *_RunThread ();
extern Thread_t *StartThread ();
extern Thread_t *WaitThread ();
extern Thread_t *GetThreadPtr ();
extern int	ChangePriority ();
extern int	_GetPriority ();

#endif					/* __STDC__ */

#endif					/* _thread_h_ */

/*** end of header thread.h ***/
