/**MO*****************************  Module  ********************************

Name	: time.h
Purpose : Functions to access processor's timers
Notes	:
SccsId	: @(#)time.h	1.4	2/1/93	
History : 11.10.91	created by Wassew, Parsytec

***/

#ifndef	_time_h_
#define	_time_h_

/**PD***************  Global Defines and Data structures  ****************/

/*
 * Structure returned by gettimeofday(2) system call,
 * and used in other calls.
 */
struct timeval {
        long    tv_sec;         /* seconds */
        long    tv_usec;        /* and microseconds */
};

/* ticks per second ... */
#define       CLK_TCK_LOW     15625           /* 64 us low-pri clock tick */
#define       CLK_TCK_HIGH    1000000         /* 1 us high-pri clock tick */

/**SV************************  Static variables	 **************************/

/**DF***********************  Declared Functions  *************************/

#ifdef	__STDC__
extern unsigned int TimeNowLow (void);
extern unsigned int TimeNowHigh (void);
extern void     TimeWaitLow (unsigned int);
extern void     TimeWaitHigh (unsigned int);
extern int      TimeAfter (unsigned int time1, unsigned int time2);

#else

extern unsigned int TimeNowLow ();
extern unsigned int TimeNowHigh ();
extern          TimeWaitLow ();
extern          TimeWaitHigh ();
extern int      TimeAfter ();

#endif					/* __STDC__ */

#endif					/* _time_h_ */

/*** end of time.h ***/
