#ifndef _TYPES_H
#define _TYPES_H

/*
 * SCCSID("@ (#)types.h	92.1 (92/12/09)");
 *
 * (c) 1985 ACE	Associated Computer Experts bv,
 *		Amsterdam,
 *		The Netherlands.
 */

#ifndef NOTDEFINED
typedef unsigned char	byte;
typedef unsigned int	uint;
typedef unsigned short	ushort;
typedef unsigned long	ulong;

typedef long	daddr_t;  	/* disk address */
typedef	char *	paddr_t;	/* Physical address */
typedef char *	caddr_t;  	/* core address */
typedef char *	uaddr_t;  	/* user address */
typedef ushort	ino_t;     	/* i-node number */
#include <sys/time_t.h>
typedef short	dev_t;		/* device code */
typedef long	off_t;    	/* offset in file */
#include <sys/size_t.h>
#include <sys/clock_t.h>
typedef ushort	gid_t;		/* group IDs */
typedef ushort	pid_t;		/* process IDs */
typedef ushort	uid_t;		/* user IDs */
typedef ushort	mode_t;		/* file attributes */
typedef ushort	nlink_t;	/* link counts */

typedef ushort	pri_t;		/* priority type */
typedef ushort	id_t;		/* identification type */
typedef long	key_t;		/* key to a semaphore or message queue */
typedef long	reg_t;		/* the register type variable */
typedef ushort	imode_t;	/* type of i_mode */
typedef ulong	clkl_t;		/* length variables in clicks */
typedef ulong	clka_t;		/* address expressed in clicks. */
typedef ulong	swpl_t;		/* length in swap blocks */
typedef ulong	swpb_t;		/* the type of a swapblock number,
				 * i.e. blocknumber relative to
				 * swplo.
				 */

/*
 * Combination of all standard types. (used by access of dontcare).
 */
union	combin {
	char	chr;
	byte	bt;
	short	shrt;
	ushort	ushrt;
	long	lng;
	ulong	ulng;
} ;

/*
 * Vector table used to initialize vector areas
 */
struct vector {
	short	number;
	caddr_t	pointer;
} ;
#endif /* NOTDEFINED */

/**MO**************************   Module   *******************************

Name	: types.h
Purpose	:
Notes	: extensions to the ACE version
SccsId	: @(#)types.h	1.2	5/11/92
History	: 03.09.91 	created by Nowak, Parsytec

***/

#define	FALSE	0
#define	TRUE	1

typedef int		word;
typedef unsigned int	Channel_t;

#ifndef _POSIX_SOURCE
typedef unsigned char	u_char;
typedef unsigned short	u_short;
typedef unsigned int	u_int;
typedef unsigned long	u_long;

struct iovec {
    caddr_t         iov_base;
    int             iov_len;
};

/*
 * File descriptor set for select, plus macros to manipulate it
 */

typedef struct fd_set {
    int             fds_bits[2];
}               fd_set;

#define bitsperint (sizeof(int)*8)

#define FD_SETSIZE	64

#define FD_SET(fd,fdset) 		\
		((fdset)->fds_bits[(fd)/bitsperint]|=(1<<((fd)%bitsperint)))
#define FD_CLR(fd,fdset)		\
		((fdset)->fds_bits[(fd)/bitsperint]&=~(1<<((fd)%bitsperint)))
#define FD_ISSET(fd,fdset)		\
		((fdset)->fds_bits[(fd)/bitsperint]&(1<<((fd)%bitsperint)))
#define FD_ZERO(fdset)			\
		((fdset)->fds_bits[0]=0,(fdset)->fds_bits[1]=0)

#endif	/* ! _POSIX_SOURCE */

/*** end of extensions ***/

#endif	/* _TYPES_H */
