/*
 *	@(#)time.h	92.1	92/12/09	ACE
 *
 *	Date and time.
 */

/* $Header: time.h,v 1.6 90/04/23 13:24:50 eck Exp $ */

#ifndef _TIME_H
#define	_TIME_H

#include <null.h>
#include <unistd.h>

#define	CLK_TCK	(sysconf(_SC_CLK_TCK))

#include <sys/size_t.h>
#include <sys/time_t.h>
#include <sys/clock_t.h>

struct tm {
	int	tm_sec;			/* seconds after the minute - [0, 59] */
	int	tm_min;			/* minutes after the hour - [0, 59] */
	int	tm_hour;		/* hours since midnight - [0, 23] */
	int	tm_mday;		/* day of the month - [1, 31] */
	int	tm_mon;			/* months since January - [0, 11] */
	int	tm_year;		/* years since 1900 */
	int	tm_wday;		/* days since Sunday - [0, 6] */
	int	tm_yday;		/* days since January 1 - [0, 365] */
	int	tm_isdst;		/* Daylight Saving Time flag */
};

#ifdef __STDC__

/* clock() returns time in microseconds */
#define	CLOCKS_PER_SEC		1000000

clock_t		clock(void);
double		difftime(time_t _time1, time_t _time0);
time_t		mktime(struct tm *_timeptr);
time_t		time(time_t *_timeptr);
char		*asctime(const struct tm *_timeptr);
char		*ctime(const time_t *_timer);
struct	tm	*gmtime(const time_t *_timer);
struct	tm	*localtime(const time_t *_timer);
size_t		strftime(char *_s, size_t _maxsize,
			const char *_format,
			const struct tm *_timeptr);
void	tzset(void);
long	sysconf(int _name);

extern long	timezone;
extern int	daylight;
extern char	*tzname[];

#else /* !__STDC__ */

extern struct tm	*gmtime(), *localtime();
extern char	*ctime(), *asctime();
extern void	tzset();
extern clock_t	clock();
extern double	difftime();
extern long	sysconf();

extern long	timezone;
extern int	daylight;
extern char	*tzname[];

#endif /* __STDC__ */

#endif /* _TIME_H */
