#ifndef _UNISTD_H
#define _UNISTD_H

/*
 * SCCSID("@(#)unistd.h	92.1 (92/12/09)");
 *
 * (c) 1991 ACE	Associated Computer Experts bv,
 *		Amsterdam,
 *		The Netherlands.
 */

# include	<sys/types.h>


#include <null.h>

/* Symbolic constants for access().					*/
#define R_OK	4	/* Test for read permission.			*/
#define W_OK	2	/* Test for write permission.			*/
#define X_OK	1	/* Test for execute/search permission.		*/
#define F_OK	0	/* Test for existence.				*/

/* Symbolic constants for lockf().					*/
#define F_ULOCK	0	/* Unlock a previously locked region.		*/
#define F_LOCK	1	/* Lock a region for exclusive use.		*/
#define F_TLOCK	2	/* Test and lock a region for exclusive use.	*/
#define F_TEST	3	/* Test a region for a previous lock.		*/

#include <seek.h>

/* Path names of the passwd and group files.				*/
#define GF_PATH	"/etc/group"	/* Path name of the group file.		*/
#define PF_PATH	"/etc/passwd"	/* Path name of the passwd file.	*/
#define IF_PATH	"/usr/include"	/* Path name for <...> files.		*/

/* Symbolic constants for sysconf().					*/
#define _SC_ARG_MAX	0	
#define _SC_CHILD_MAX	1	
#define _SC_CLK_TCK	2	
#define _SC_JOB_CONTROL	3	
#define _SC_NGROUPS_MAX	4	
#define _SC_OPEN_MAX	5	
#define _SC_PASS_MAX	6	
#define _SC_SAVED_IDS	7	
#define _SC_VERSION	8	
#define _SC_XOPEN_VERSION 9	

/* Symbolic constants for pathconf().					*/
#define _PC_CHOWN_RESTRICTED	0
#define _PC_LINK_MAX		1
#define _PC_MAX_CANON		2
#define _PC_MAX_INPUT		3
#define _PC_NAME_MAX		4
#define _PC_NO_TRUNC		5
#define _PC_PATH_MAX		6
#define _PC_PIPE_BUF		7
#define _PC_VDISABLE		8

/* File streams. */
#define	STDIN_FILENO	0	/* standard input */
#define	STDOUT_FILENO	1	/* standard output */
#define	STDERR_FILENO	2	/* standard error output */

/* Compliance versions. */
#define	_POSIX_VERSION	198808L
#define	_XOPEN_VERSION	3

/* Standard functions. */
extern int	access ();
extern int	chdir ();
extern int	chown ();
extern int	close ();
extern char	* ctermid ();
extern char	* cuserid ();
extern int	dup ();
extern int	dup2 ();
extern void	_exit ();
extern long	fpathconf ();
extern char	* getcwd ();
extern gid_t	getegid ();
extern uid_t	geteuid ();
extern gid_t	getgid ();
extern int	getgroups ();
extern char	* getlogin ();
extern pid_t	getpid ();
extern pid_t	getppid ();
extern uid_t	getuid ();
extern int	isatty ();
extern int	link ();
extern off_t	lseek ();
extern long	pathconf ();
extern int	read ();
extern int	rename ();
extern int	rmdir ();
extern int	setgid ();
extern pid_t	setsid ();
extern int	setuid ();
extern long	sysconf ();
extern char	* ttyname ();
extern int	unlink ();
extern int	write ();

#endif /* _UNISTD_H */
