/*				falls errno benutzt werden soll.
*/
#define	ERRNO

/*
**	SccsId:		@(#)vt_lib.h	1.3 11/27/92
**	file:           vt_lib.h
**	version:	16.02.1992
**	author:		Jens Simon, Uni-Paderborn
**
**	comment: Globales Header-File fuer alle Module der Library
*/

/* Schaltet interne Librarytests ein */
#define	TESTMODE

/**HE*********************   Header   ****************************************/
#include <sys/root.h>
#include <virt_top.h>

#ifdef	ERRNO
#include <errno.h>
#endif

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/**PD*********************   Defines and Data Structures   *******************/

#define	MyProcId	( GET_ROOT()->ProcRoot->MyProcID )
#define	gc_MyId		( GET_ROOT()->ProcRoot->MyProcID )
#define	nProcs		( GET_ROOT()->ProcRoot->nProcs )
#define	DimX		( GET_ROOT()->ProcRoot->DimX )
#define	DimY		( GET_ROOT()->ProcRoot->DimY )
#define	DimZ		( GET_ROOT()->ProcRoot->DimZ )
#define	MyX		( GET_ROOT()->ProcRoot->MyX )
#define	MyY		( GET_ROOT()->ProcRoot->MyY )
#define	MyZ		( GET_ROOT()->ProcRoot->MyZ )

#define	PRINTXYZ(x,y,z,s,p0,p1,p2,p3) \
			if (MyX == x && MyY == y && MyZ == z) \
				printf (s,p0,p1,p2,p3)

/**PV*********************   Variables and Functions  ************************/

#ifdef _VT_MAIN
char vt_error[81];
#else
extern char vt_error[81];
#endif

#define	Min(a,b)	( ((a) <= (b)) ? (a) : (b) )
#define	Max(a,b)	( (a > b) ? a : b )
#define	Abs(x)		(((x)<0) ? -(x) : (x))
#define	Diff(a,b)	( (a >= b) ? a-b : b-a )
#define CeilDiv(a,b)    ( ((a)/(b))*(b) < (a) ? ((a)/(b))+1 : (a)/(b) )

/********* Funktionen aus vt_main.c:  ***/
extern int	PId_von_PPos (int *p_Id, PPos_t pos, PPos_t p_Dim);
extern int	PPos_von_PId (PPos_t * pos, int p_Id, PPos_t p_Dim);
extern int	GCId_von_GCPos (int *gc_Id, GCPos_t pos);
extern int	GCPos_von_GCId (GCPos_t * pos, int Id);
extern int	GCId_von_PId (int *gc_Id, int p_Id,
				PPos_t p_Dim, GCPos_t gc_Offset);
extern int	PId_von_GCId (int *p_Id, int gc_Id,
				PPos_t p_Dim, GCPos_t gc_Offset);
extern int	Partition_Test (int *p_Procs, int *xmin, int *xmax,
				int *ymin, int *ymax, int *zmin, int *zmax);
extern	int	SetPipeLinks (LinkCB_t **link0, LinkCB_t **link1, int id,
				int gcId_down, int gcId_up, int reqId);
extern	int	SetRingLinks (LinkCB_t **link0, LinkCB_t **link1, int id,
			int gcId_down, int gcId_up, int reqId, int ringSize);
extern	int	Argtest2D (int t_dim_x, int t_dim_y,
		    int *xmin, int *xmax, int *ymin, int *ymax, int *zmin, int *zmax);
extern	int	Argtest3D (int dim_x, int dim_y, int dim_z,
		    int *xmin, int *xmax, int *ymin, int *ymax, int *zmin, int *zmax);
extern	int	SetHcLinks (LinkCB_t **link, int id, int dimension,
			int gcId_target, int reqId);
extern	int	Opt_Grid (int *a, int *b, int x, int y, int size);

/********* Funktionen aus vt_pipe.c:  ***/

extern	int
PipeId_von_PPos (int *pi_Id, PPos_t p_Pos, PPos_t p_Dim);

extern	int
PPos_von_PipeId (PPos_t *p_pos, int pi_Id, PPos_t p_Dim);

/********* Funktionen aus vt_gr2d.c:  ***/

extern	int
Grid2D_Methode (int *opt_Methode, int *dilation,
			Pos2D_t g_Dim, PPos_t p_Dim);
extern	int
Grid2DId_von_PPos (Pos2D_t * g_Id, PPos_t p_pos, Pos2D_t g_dim, PPos_t p_dim,
			int opt_Methode);
extern	int
PPos_von_Grid2DId (PPos_t *p_Pos, Pos2D_t g_Id, Pos2D_t g_dim, PPos_t p_dim,
			int opt_Methode);

extern	int
Grid2DId_von_PId (Pos2D_t * g_Id, int p_Id,
			Pos2D_t g_Dim, PPos_t p_Dim, int opt_Methode);
extern	int
PId_von_Grid2DId (int *p_Id, Pos2D_t g_Id,
			Pos2D_t g_Dim, PPos_t p_Dim, int opt_Methode);

/********* Funktionen aus vt_gr3d.c:  ***/

extern	int
Grid3D_Methode (int *g3D_opt_Methode, int *g2D_opt_Methode,
			int *dilation, Pos3D_t g_Dim, PPos_t p_Dim);

extern	int
Grid3DId_von_PPos (Pos3D_t * g_Id, PPos_t p_Pos, Pos3D_t g_Dim, PPos_t p_Dim,
			int g3D_opt_Methode, int g2D_opt_Methode);
extern	int
PPos_von_Grid3DId (PPos_t * p_Pos, Pos3D_t g_Id, Pos3D_t g_Dim, PPos_t p_Dim,
			int g3D_opt_Methode, int g2D_opt_Methode);

/********* Funktionen aus vt_to2d.c:  ***/

extern	int
Torus2D_Methode (int *opt_Methode, int *dilation, Pos2D_t t_Dim, PPos_t p_Dim);
extern	int
PPos_von_Torus2DId (PPos_t * p_Pos, Pos2D_t t_Id,
			Pos2D_t t_dim, PPos_t p_dim, int opt_Methode);
extern	int
Torus2DId_von_PPos (Pos2D_t *t_id, PPos_t p_pos, Pos2D_t t_dim,
			PPos_t p_dim, int opt_Methode);

/********* Funktionen aus vt_to3d.c:  ***/

extern	int
Torus3D_Methode (int *t3D_opt_Methode, int *t2D_opt_Methode,
			int *dilation, Pos3D_t t_Dim, PPos_t p_Dim);
extern	int
Torus3DId_von_PPos (Pos3D_t *t_Id, PPos_t p_Pos, Pos3D_t t_Dim, PPos_t p_Dim,
			int t3D_opt_Methode, int t2D_opt_Methode);
extern	int
PPos_von_Torus3DId (PPos_t * p_Pos, Pos3D_t t_Id, Pos3D_t t_Dim, PPos_t p_Dim,
			int t3D_opt_Methode, int t2D_opt_Methode);

/********* Funktionen aus vt_clique.c:  ***/

extern	int
CId_von_GCId (int *c_Id, int gc_Id, int size, PPos_t p_Dim, GCPos_t gc_Offset);

extern	int
GCId_von_CId (int *gc_Id, int cId, int size, PPos_t p_Dim, GCPos_t gc_Offset);

/*******************************************************************************/

extern char *_LIBVTID_;
