# Makefile for PARIX Release installation
#       (C) Parsytec GmbH 1993
#
# SCCSid:      @(#)inst.mk	1.4     3/1/93

CC	=	/usr/bin/cc

.SILENT:

include         ./px_config.dat

.INIT:          ./privileges

TAR_PATH:sh	=	pwd

install:	new-module
	(echo "setenv PARIX $(PARIX)"; \
	echo "set path = ( \$$path \$${PARIX}/bin)") > $(PARIX)/setup
	# chown $(PX_OWN).$(PX_GRP) $(PARIX)/setup

new-module:	$(TAR) $(LICENSES)
	diff ./px_config.dat $(PARIX)/px_config.dat > /dev/null 2>&1 || \
	(echo "* copying px_config.dat to $(PARIX)";\
	install -c -g $(PX_GRP) -o $(PX_OWN) -m 640 ./px_config.dat $(PARIX))
	diff ./px_config.c $(PARIX)/px_config.c > /dev/null 2>&1 || \
	(echo "* copying px_config.c to $(PARIX)"; \
	install -c -g $(PX_GRP) -o $(PX_OWN) -m 640 ./px_config.c $(PARIX))
	cd $(PARIX)/install; $(MAKE) $(MFLAGS) doit

$(TAR):
	echo "* extracting $(TAR_PATH)/$@.tar to $(PARIX)"
	cd $(PARIX); tar -xvpf $(TAR_PATH)/$@.tar

$(LICENSES):
	# Writing the license numbers into $(PARIX)/lib/spr/licenses
	grep $@ $(PARIX)/lib/spr/licenses >/dev/null ||\
	echo $@ >>$(PARIX)/lib/spr/licenses

uninstall:	privileges
	echo -n "remove $(PARIX) directory? "
	read i;\
	if test "$$i" = 'y' || test "$$i" = 'yes';\
	then (rm -r $(PARIX) && echo "* $(PARIX) removed") ;\
	else echo "* $(PARIX) not removed" ;\
	fi

privileges:	checkroot
	# ./checkroot;\
	# Insufficient privileges! \
	# To perform this action you must be the Superuser!

.c:
	echo "* compiling $@"
	$(CC) $(OPTS) -o ./$@ ./$*.c

clean:
	echo "* removing checkroot"
	-rm -f ./checkroot
